%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Course: ECE438
%name: Yang Zhu
%last updated Date: 2011/12/4
%Description:calculate the slope of the image
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function y = calc_slope(x)
    [row,col]=size(x);
    col = round(col/3);
    x = x(1:row,1:col);
    y(:,1)=abs(x(:,1)-x(:,1));
    y(:,col)=abs(x(:,col)-x(:,col));
    y(1,:)=abs(x(1,:)-x(1,:));
    y(row,:)=abs(x(row,:)-x(row,:));

    for m=2:row-1
        for n=2:col-1
%             temp = 0;
            temp1(1) = abs(x(m,n)-x(m-1,n));
            temp1(2) = abs(x(m,n)-x(m,n-1));
            temp1(3) = abs(x(m,n)-x(m+1,n));
            temp1(4) = abs(x(m,n)-x(m,n+1));
            temp1(5) = (abs(x(m,n)-x(m-1,n-1)))/sqrt(2);
            temp1(6) = (abs(x(m,n)-x(m-1,n+1)))/sqrt(2);
            temp1(7) = (abs(x(m,n)-x(m+1,n+1)))/sqrt(2);
            temp1(8) = (abs(x(m,n)-x(m+1,n-1)))/sqrt(2);
            y(m,n) = round(max(temp1));
        end
    end
    y = reshape(y,1,row*col);
    
end